"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isDQLClient = isDQLClient;
exports.newCompleteStrategy = newCompleteStrategy;
var hybrid_1 = require("./hybrid");
var dql_1 = require("../client/dql");
function isDQLClient(dqlClent) {
    var client = dqlClent;
    return (typeof client.datasourceValues === 'function' &&
        typeof client.fieldNames === 'function' &&
        typeof client.indexValues === 'function' &&
        typeof client.namespace === 'function' &&
        typeof client.showFunctions === 'function');
}
function newCompleteStrategy(dqlClent) {
    if (dqlClent && isDQLClient(dqlClent)) {
        return new hybrid_1.HybridComplete(dqlClent);
    }
    return new hybrid_1.HybridComplete(new dql_1.DQLClient());
}
//# sourceMappingURL=index.js.map