"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MatherIn = exports.MatcherOp = void 0;
exports.createMatcher = createMatcher;
exports.isMatcher = isMatcher;
var lezer_dql_1 = require("@cloudcare/lezer-dql");
var path_finder_1 = require("./path-finder");
var types_1 = require("../types");
exports.MatcherOp = [lezer_dql_1.EqlSingle, lezer_dql_1.Neq, lezer_dql_1.EqlRegex, lezer_dql_1.NeqRegex];
exports.MatherIn = [lezer_dql_1.In, lezer_dql_1.NotIn];
function createMatcher(labelMatcher, state) {
    var matcher = new types_1.Matcher(0, '', state.sliceDoc(labelMatcher.from, labelMatcher.to).slice(1, -1));
    var binaryNode = (0, path_finder_1.walkBackward)(labelMatcher, lezer_dql_1.BinaryExpr);
    var cursor = binaryNode.cursor();
    if (cursor.next()) {
        do {
            if (cursor.type.id === lezer_dql_1.FilterExpr) {
                if (!cursor.next())
                    return matcher;
                switch (cursor.type.id) {
                    case lezer_dql_1.Identifier: {
                        if (matcher.type === 0) {
                            // 这里说明是左边的,正常情况下，Identifier只能出现在左边
                            matcher.name = state.sliceDoc(cursor.from, cursor.to);
                        }
                        break;
                    }
                    case lezer_dql_1.StringLiteral: {
                        if (matcher.type === 0) {
                            // 这里说明是左边的，因为左边也支持写'host' = 'xxx' 这种
                            matcher.name = state.sliceDoc(cursor.from, cursor.to).slice(1, -1);
                        }
                        break;
                    }
                    case lezer_dql_1.InFieldValue: {
                        break;
                    }
                }
                cursor.parent(); //回到上一层
            }
            else if (__spreadArray(__spreadArray([], __read(exports.MatherIn), false), __read(exports.MatcherOp), false).includes(cursor.type.id)) {
                matcher.type = cursor.type.id;
            }
        } while (cursor.nextSibling());
    }
    return matcher;
}
function isMatcher(node) {
    var _a, _b, _c;
    // 判断是否是 正常的 match 表达式，比如 a = '' a != '' a =~ '' a !~ '' a in [] a not in []
    var parentNode = node.parent;
    if (!parentNode) {
        return false;
    }
    if (parentNode.type.id === lezer_dql_1.FilterExpr && parentNode.prevSibling && exports.MatcherOp.includes(parentNode.prevSibling.type.id)) {
        // sex = '直男';
        return true;
    }
    else if (parentNode.type.id === lezer_dql_1.InFieldValue &&
        ((_b = (_a = parentNode.parent) === null || _a === void 0 ? void 0 : _a.type) === null || _b === void 0 ? void 0 : _b.id) === lezer_dql_1.FilterExpr &&
        ((_c = parentNode.parent) === null || _c === void 0 ? void 0 : _c.prevSibling) &&
        exports.MatherIn.includes(parentNode.parent.prevSibling.type.id)) {
        return true; // sex in ["a"]
    }
    return false;
}
//# sourceMappingURL=matcher.js.map