"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.darkDqlHighlighter = exports.dqlHighlighter = exports.darkTheme = exports.lightTheme = exports.baseTheme = void 0;
var language_1 = require("@codemirror/language");
var highlight_1 = require("@lezer/highlight");
var view_1 = require("@codemirror/view");
exports.baseTheme = view_1.EditorView.theme({
    '&.cm-editor': {
        '&.cm-focused': {
            outline: 'none',
            outline_fallback: 'none',
        },
    },
    '.cm-scroller': {
        overflow: 'hidden',
    },
    '.cm-placeholder': {},
    '.cm-matchingBracket': {
        fontWeight: 'bold',
        outline: '1px dashed transparent',
    },
    '.cm-nonmatchingBracket': { borderColor: 'red' },
    '.cm-tooltip.cm-tooltip-autocomplete': {
        '& > ul': {
            maxHeight: '350px',
            maxWidth: 'unset',
        },
        '& > ul > li': {
            padding: '2px 1em 2px 3px',
        },
        minWidth: '30%',
    },
    '.cm-completionDetail': {
        float: 'right',
        color: '#999',
    },
    '.cm-tooltip.cm-completionInfo': {
        marginTop: '-11px',
        padding: '10px',
        border: 'none',
        minWidth: '250px',
        maxWidth: 'min-content',
    },
    '.cm-completionInfo.cm-completionInfo-right': {
        '&:before': {
            content: "' '",
            height: '0',
            position: 'absolute',
            width: '0',
            left: '-20px',
            borderWidth: '10px',
            borderStyle: 'solid',
            borderColor: 'transparent',
        },
        marginLeft: '12px',
    },
    '.cm-completionInfo.cm-completionInfo-left': {
        '&:before': {
            content: "' '",
            height: '0',
            position: 'absolute',
            width: '0',
            right: '-20px',
            borderWidth: '10px',
            borderStyle: 'solid',
            borderColor: 'transparent',
        },
        marginRight: '12px',
    },
    '.cm-completionMatchedText': {
        textDecoration: 'none',
        fontWeight: 'bold',
    },
    '.cm-selectionMatch': {
        backgroundColor: '#e6f3ff',
    },
    '.cm-diagnostic': {
        '&.cm-diagnostic-error': {
            borderLeft: '3px solid #e65013',
        },
    },
    '.cm-completionIcon': {
        boxSizing: 'content-box',
        fontSize: '16px',
        lineHeight: '1',
        marginRight: '10px',
        verticalAlign: 'top',
        '&:after': { content: "'\\ea88'" },
        fontFamily: 'codicon',
        paddingRight: '0',
        opacity: '1',
    },
    '.cm-completionIcon-function, .cm-completionIcon-method': {
        '&:after': { content: "'\\ea8c'" },
    },
    '.cm-completionIcon-class': {
        '&:after': { content: "'○'" },
    },
    '.cm-completionIcon-interface': {
        '&:after': { content: "'◌'" },
    },
    '.cm-completionIcon-variable': {
        '&:after': { content: "'𝑥'" },
    },
    '.cm-completionIcon-constant': {
        '&:after': { content: "'\\eb5f'" },
    },
    '.cm-completionIcon-type': {
        '&:after': { content: "'𝑡'" },
    },
    '.cm-completionIcon-enum': {
        '&:after': { content: "'∪'" },
    },
    '.cm-completionIcon-property': {
        '&:after': { content: "'□'" },
    },
    '.cm-completionIcon-keyword': {
        '&:after': { content: "'\\eb62'" },
    },
    '.cm-completionIcon-namespace': {
        '&:after': { content: "'▢'" },
    },
    '.cm-completionIcon-text': {
        '&:after': { content: "'\\ea95'" },
        color: '#ee9d28',
    },
});
exports.lightTheme = view_1.EditorView.theme({
    '.cm-tooltip': {
        backgroundColor: '#f8f8f8',
        borderColor: 'rgba(52, 79, 113, 0.2)',
    },
    '.cm-tooltip.cm-tooltip-autocomplete': {
        '& li:hover': {
            backgroundColor: '#ddd',
        },
        '& > ul > li[aria-selected]': {
            backgroundColor: '#d6ebff',
            color: 'unset',
        },
    },
    '.cm-tooltip.cm-completionInfo': {
        backgroundColor: '#d6ebff',
    },
    '.cm-tooltip > .cm-completionInfo.cm-completionInfo-right': {
        '&:before': {
            borderRightColor: '#d6ebff',
        },
    },
    '.cm-tooltip > .cm-completionInfo.cm-completionInfo-left': {
        '&:before': {
            borderLeftColor: '#d6ebff',
        },
    },
    '.cm-line': {
        '&::selection': {
            backgroundColor: '#add6ff',
        },
        '& > span::selection': {
            backgroundColor: '#add6ff',
        },
    },
    '.cm-matchingBracket': {
        color: '#000',
        backgroundColor: '#dedede',
    },
    '.cm-completionMatchedText': {
        color: '#0066bf',
    },
    '.cm-completionIcon': {
        color: '#007acc',
    },
    '.cm-completionIcon-constant': {
        color: '#007acc',
    },
    '.cm-completionIcon-function, .cm-completionIcon-method': {
        color: '#652d90',
    },
    '.cm-completionIcon-keyword': {
        color: '#616161',
    },
}, { dark: false });
exports.darkTheme = view_1.EditorView.theme({
    '.cm-content': {
        caretColor: '#fff',
    },
    '.cm-tooltip.cm-completionInfo': {
        backgroundColor: '#333338',
    },
    '.cm-tooltip > .cm-completionInfo.cm-completionInfo-right': {
        '&:before': {
            borderRightColor: '#333338',
        },
    },
    '.cm-tooltip > .cm-completionInfo.cm-completionInfo-left': {
        '&:before': {
            borderLeftColor: '#333338',
        },
    },
    '.cm-line': {
        '&::selection': {
            backgroundColor: '#767676',
        },
        '& > span::selection': {
            backgroundColor: '#767676',
        },
    },
    '.cm-matchingBracket, &.cm-focused .cm-matchingBracket': {
        backgroundColor: '#616161',
    },
    '.cm-completionMatchedText': {
        color: '#7dd3fc',
    },
    '.cm-completionIcon, .cm-completionIcon-constant': {
        color: '#7dd3fc',
    },
    '.cm-completionIcon-function, .cm-completionIcon-method': {
        color: '#d8b4fe',
    },
    '.cm-completionIcon-keyword': {
        color: '#cbd5e1 !important',
    },
}, { dark: true });
exports.dqlHighlighter = language_1.HighlightStyle.define([
    { tag: highlight_1.tags.number, color: '#09885a' },
    { tag: highlight_1.tags.string, color: '#a31515' },
    { tag: highlight_1.tags.keyword, color: '#008080' },
    { tag: highlight_1.tags.function(highlight_1.tags.variableName), color: '#008080' },
    { tag: highlight_1.tags.labelName, color: '#800000' },
    { tag: highlight_1.tags.operator, color: '#008080' },
    { tag: highlight_1.tags.modifier, color: '#008080' },
    { tag: highlight_1.tags.paren },
    { tag: highlight_1.tags.squareBracket },
    { tag: highlight_1.tags.brace },
    { tag: highlight_1.tags.invalid, color: 'red' },
    { tag: highlight_1.tags.comment, color: '#888', fontStyle: 'italic' },
]);
exports.darkDqlHighlighter = language_1.HighlightStyle.define([
    { tag: highlight_1.tags.number, color: '#22c55e' },
    { tag: highlight_1.tags.string, color: '#fca5a5' },
    { tag: highlight_1.tags.keyword, color: '#14bfad' },
    { tag: highlight_1.tags.function(highlight_1.tags.variableName), color: '#14bfad' },
    { tag: highlight_1.tags.labelName, color: '#ff8585' },
    { tag: highlight_1.tags.operator, color: '#14bfad' },
    { tag: highlight_1.tags.modifier, color: '#14bfad' },
    { tag: highlight_1.tags.paren },
    { tag: highlight_1.tags.squareBracket },
    { tag: highlight_1.tags.brace },
    { tag: highlight_1.tags.invalid, color: '#ff3d3d' },
    { tag: highlight_1.tags.comment, color: '#9ca3af', fontStyle: 'italic' },
]);
//# sourceMappingURL=theme.js.map