import { Matcher } from '../types';
export interface NamespaceData {
    name: string;
    help: string;
}
export interface ShowFuncData {
    info: string;
    name: string;
}
export interface FieldNameData {
    info: string;
    type: string;
    name: string;
}
export declare class DQLClient {
    constructor();
    namespace(): Promise<NamespaceData[]>;
    showFunctions(): Promise<ShowFuncData[]>;
    indexValues(namespace: string): Promise<string[]>;
    datasourceValues(namespace: string, indexs?: string[]): Promise<string[]>;
    fieldValues(namespace: string, indexs?: string[], datasource?: string[], matcher?: Matcher): Promise<string[]>;
    fieldNames(namespace: string, indexs?: string[], datasource?: string[]): Promise<FieldNameData[]>;
}
