import { snippet } from '@codemirror/autocomplete';
export const durationTerms = [{ label: 'y' }, { label: 'w' }, { label: 'd' }, { label: 'h' }, { label: 'm' }, { label: 's' }, { label: 'ms' }];
export const matchOpTerms = [{ label: '=' }, { label: '!=' }, { label: '=~' }, { label: '!~' }, { label: 'in' }, { label: 'not in' }];
export const binOpTerms = [
    { label: '^' },
    { label: '*' },
    { label: '/' },
    { label: '%' },
    { label: '+' },
    { label: '-' },
    { label: '==' },
    { label: '>=' },
    { label: '>' },
    { label: '<' },
    { label: '<=' },
    { label: '!=' },
    { label: '&&' },
    { label: '||' },
];
export const connectOpTerms = [{ label: 'and' }, { label: 'or' }];
// Abs,
//   Ceil,
//   CountDistinct,
//   CountSeries,
//   Derivative,
//   Difference,
//   Distinct,
//   Floor,
//   Rate,
//   Irate,
//   Deriv,
//   Increase,
//   Log,
//   Log10,
//   Log2,
//   Max,
//   Min,
//   Mode,
//   NonNegativeDerivative,
//   NonNegativeDifference,
//   Round,
//   Spread,
//   Stddev,
//   Sum,
//   Schema,
//   DistinctByCollapse,
//   Default,
//   Fill,
//   CountFilter,
//   Count,
//   First,
//   Any,
//   Last,
//   LastRow,
//   Bottom,
//   Top,
//   MovingAverage,
//   Percentile,
//   Median,
//   Set,
//   Int,
//   Float,
//   String,
//   Md5,
//   Histogram,
//   Exists,
//   Cidr,
//   Match,
//   Regex,
//   Re,
//   Regexp,
//   RegexpExtract,
//   RegexpExtractAll,
//   Collect,
//   Concat,
//   Drain,
//   Wildcard,
//   QueryString,
//   Querystring,
//   WithLabels,
//   WithoutLabels,
//   Unwrap,
//   Now,
//   Cumsum,
//   Window,
//   Dbscan,
//   Eval,
//   Avg,
export const functionIdentifierTerms = [
    {
        label: 'abs',
        detail: 'function',
        info: 'Return absolute values of input series',
        type: 'function',
    },
    { label: 'ceil', detail: 'function', info: 'Round up to the nearest integer', type: 'function' },
    { label: 'count', detail: 'function', info: 'Count the number of elements in a series', type: 'function' },
    { label: 'count_distinct', detail: 'function', info: 'Count the number of distinct elements in a series', type: 'function' },
    { label: 'count_series', detail: 'function', info: 'Count the number of series in a query', type: 'function' },
    { label: 'derivative', detail: 'function', info: 'Calculate the derivative of a series', type: 'function' },
    { label: 'difference', detail: 'function', info: 'Calculate the difference between consecutive values in a series', type: 'function' },
    { label: 'distinct', detail: 'function', info: 'Return distinct values from a series', type: 'function' },
    { label: 'floor', detail: 'function', info: 'Round down to the nearest integer', type: 'function' },
    { label: 'rate', detail: 'function', info: 'Calculate the per-second rate of increase of a time series', type: 'function' },
    { label: 'irate', detail: 'function', info: 'Calculate the per-second instant rate of increase of a time series', type: 'function' },
    {
        label: 'deriv',
        detail: 'function',
        info: 'Calculate the derivative of a series',
        type: 'function',
    },
    { label: 'increase', detail: 'function', info: 'Calculate the increase of a series over a specified time period', type: 'function' },
    { label: 'log', detail: 'function', info: 'Calculate the natural logarithm of a series', type: 'function' },
    { label: 'log10', detail: 'function', info: 'Calculate the base-10 logarithm of a series', type: 'function' },
    { label: 'log2', detail: 'function', info: 'Calculate the base-2 logarithm of a series', type: 'function' },
    { label: 'max', detail: 'function', info: 'Return the maximum value from a series', type: 'function' },
    { label: 'min', detail: 'function', info: 'Return the minimum value from a series', type: 'function' },
    { label: 'mode', detail: 'function', info: 'Return the mode (most frequent value) from a series', type: 'function' },
    { label: 'non_negative_derivative', detail: 'function', info: 'Calculate the non-negative derivative of a series', type: 'function' },
    {
        label: 'non_negative_difference',
        detail: 'function',
        info: 'Calculate the non-negative difference between consecutive values in a series',
        type: 'function',
    },
    { label: 'round', detail: 'function', info: 'Round values in a series to the nearest integer', type: 'function' },
    { label: 'spread', detail: 'function', info: 'Calculate the spread (difference between max and min) of a series', type: 'function' },
    { label: 'stddev', detail: 'function', info: 'Calculate the standard deviation of a series', type: 'function' },
    { label: 'sum', detail: 'function', info: 'Calculate the sum of values in a series', type: 'function' },
    { label: 'schema', detail: 'function', info: 'Return the schema of a series', type: 'function' },
    { label: 'distinct_by_collapse', detail: 'function', info: 'Collapse a series to distinct values', type: 'function' },
    { label: 'default', detail: 'function', info: 'Set a default value for a series', type: 'function' },
    {
        label: 'fill',
        detail: 'function',
        info: 'Fill missing values in a series with a specified value',
        type: 'function',
    },
    { label: 'count_filter', detail: 'function', info: 'Count the number of elements that match a filter in a series', type: 'function' },
    { label: 'first', detail: 'function', info: 'Return the first value from a series', type: 'function' },
    { label: 'any', detail: 'function', info: 'Return any value from a series', type: 'function' },
    { label: 'last', detail: 'function', info: 'Return the last value from a series', type: 'function' },
    { label: 'last_row', detail: 'function', info: 'Return the last row of a series', type: 'function' },
    { label: 'bottom', detail: 'function', info: 'Return the bottom N values from a series', type: 'function' },
    { label: 'top', detail: 'function', info: 'Return the top N values from a series', type: 'function' },
    { label: 'moving_average', detail: 'function', info: 'Calculate the moving average of a series', type: 'function' },
    { label: 'percentile', detail: 'function', info: 'Calculate the percentile of a series', type: 'function' },
    { label: 'median', detail: 'function', info: 'Calculate the median of a series', type: 'function' },
    { label: 'set', detail: 'function', info: 'Set values in a series based on conditions', type: 'function' },
    { label: 'int', detail: 'function', info: 'Convert values in a series to integers', type: 'function' },
    { label: 'float', detail: 'function', info: 'Convert values in a series to floats', type: 'function' },
    { label: 'string', detail: 'function', info: 'Convert values in a series to strings', type: 'function' },
    { label: 'md5', detail: 'function', info: 'Calculate the MD5 hash of values in a series', type: 'function' },
    { label: 'histogram', detail: 'function', info: 'Create a histogram from a series of values', type: 'function' },
    { label: 'exists', detail: 'function', info: 'Check if a value exists in a series', type: 'function' },
    { label: 'cidr', detail: ' function', info: ' Check if an IP address is within a CIDR range', type: ' function' },
    { label: 'match', detail: ' function', info: ' Match values against a pattern', type: ' function' },
    { label: 'regex', detail: ' function', info: ' Match values against a regular expression', type: ' function' },
    { label: 're', detail: ' function', info: ' Match values against a regular expression (alias for regex)', type: ' function' },
    { label: 'regexp_extract', detail: ' function', info: ' Extract substrings from values using regular expressions', type: ' function' },
    {
        label: 'regexp_extract_all',
        detail: 'function',
        info: 'Extract all matching substrings from values using regular expressions',
        type: 'function',
    },
    { label: 'collect', detail: ' function', info: ' Collect values into a list or array', type: ' function' },
    { label: 'concat', detail: ' function', info: ' Concatenate values in a series', type: ' function' },
    { label: 'drain', detail: ' function', info: ' Drain values from a series', type: ' function' },
    { label: 'wildcard', detail: ' function', info: ' Match values using wildcard patterns', type: ' function' },
    { label: 'query_string', detail: ' function', info: ' Parse and evaluate a query string', type: ' function' },
    { label: 'querystring', detail: ' function', info: ' Parse and evaluate a query string (alias for query_string)', type: ' function' },
    { label: 'with_labels', detail: ' function', info: ' Add labels to a series', type: ' function' },
    { label: 'without_labels', detail: ' function', info: ' Remove labels from a series', type: ' function' },
    { label: 'unwrap', detail: ' function', info: ' Unwrap values in a series', type: ' function' },
    { label: 'now', detail: ' function', info: ' Get the current time or timestamp', type: ' function' },
    { label: 'cumsum', detail: ' function', info: ' Calculate the cumulative sum of a series', type: ' function' },
    { label: 'window', detail: ' function', info: ' Create a sliding window over a series of values', type: 'function' },
    { label: 'dbscan', detail: 'function', info: 'Perform DBSCAN clustering on a series of values', type: 'function' },
    { label: 'eval', detail: 'function', info: 'Evaluate an expression in the context of a series', type: 'function' },
    { label: 'avg', detail: 'function', info: 'Calculate the average of a series', type: 'function' },
];
export const snippets = [
    {
        label: "count_filter(__field__, ['__field_value__'])",
        type: 'function',
        detail: 'snippet',
        info: 'Count the number of elements that match a filter in a series',
        apply: snippet("count_filter(${__field__}, ['${__field_value__}'])"),
    },
    {
        label: 'moving_average(`__field__`, __window_size__)',
        type: 'function',
        detail: 'snippet',
        info: 'Calculate the moving average of a series',
        apply: snippet('moving_average(`${__field__}`, ${__window_size__})'),
    },
    {
        label: 'histogram(__field__,__start_value__, __end_value__, __interval, __min_doc__)',
        detail: 'snippet',
        info: 'Create a histogram from a series of values',
        type: 'function',
        apply: snippet('histogram(${__field__},${__start_value__}, ${__end_value__}, ${__interval}, ${__min_doc__}))'),
    },
];
//# sourceMappingURL=dql.terms.js.map