import { HybridComplete } from './hybrid';
import { DQLClient } from '../client/dql';
export function isDQLClient(dqlClent) {
    const client = dqlClent;
    return (typeof client.datasourceValues === 'function' &&
        typeof client.fieldNames === 'function' &&
        typeof client.indexValues === 'function' &&
        typeof client.namespace === 'function' &&
        typeof client.showFunctions === 'function');
}
export function newCompleteStrategy(dqlClent) {
    if (dqlClent && isDQLClient(dqlClent)) {
        return new HybridComplete(dqlClent);
    }
    return new HybridComplete(new DQLClient());
}
//# sourceMappingURL=index.js.map